=== freebsd/netperfmeter/Makefile ===
PORTNAME=	netperfmeter
DISTVERSION=	2.0.1
PORTREVERSION=	1
CATEGORIES=	benchmarks
MASTER_SITES=	https://www.nntb.no/~dreibh/netperfmeter/download/

MAINTAINER=	dreibh@simula.no
COMMENT=	Network Performance Meter
WWW=		https://www.nntb.no/~dreibh/netperfmeter/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

BUILD_DEPENDS=	gm:graphics/GraphicsMagick \
		pdf2svg:graphics/pdf2svg

USES=		cmake desktop-file-utils ghostscript shebangfix tar:xz

RUN_DEPENDS=	R-cran-bit64>0:devel/R-cran-bit64 \
		R-cran-data.table>0:devel/R-cran-data.table \
		R-cran-dplyr>0:math/R-cran-dplyr \
		R-cran-ggplot2>0:graphics/R-cran-ggplot2 \
		R-cran-R.utils>0:devel/R-cran-R.utils

SHEBANG_FILES=	src/pdfembedfonts src/plot-netperfmeter-results \
		src/setpdfmetadata

CMAKE_OFF=	WITH_TEST_PROGRAMS
CMAKE_ON=	WITH_ICONS WITH_PLOT_PROGRAMS

# Work-around for build issue on ARM (https://bugs.freebsd.org/285706):
MAKE_ENV=       OMP_NUM_THREADS=1

.include <bsd.port.mk>
